﻿
import java.awt.*;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.awt.image.PixelGrabber;
import java.io.File;

import javax.imageio.ImageIO;
import javax.swing.*;

import java.awt.Color;
import java.awt.Graphics;


public class JDE1 extends JFrame implements ActionListener {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 6269783843926374222L;
	public BufferedImage image0;
	public BufferedImage image1;
	public BufferedImage image2;
	public BufferedImage image3;
	public BufferedImage image4;
	public BufferedImage image5;
	public BufferedImage image6;
	public BufferedImage image7;
	public BufferedImage image8;
	
	public final int WIDTH = 26;
	public final int HEIGHT = 34;
	public final int MEM = 9;
	
	public int scale;
	public int width1;
	public int height1;
	
	public int xs;
	public int ys;
	
	public int[] sumX;
	public int[] sumY;
	public int[][] stX;
	public int[][] edX;
	public int[] stY;
	public int[] edY;
	public int[] frameX;
	public int[] frameY;
	public int[] frameW;
	public int[] frameH;
	public int[] fcenterX;
	public int[] fcenterY;
	public int frameN = 0;
	public int fcnt = 0;
	public int nMin;
	public int[] ntX;
	public int[] neck;
	public int ntY;
	public final int THR = 128;
	public final int THG = 128;
	public final int THB = 128;
	public final int THL = 145;
	public final int CUT = 0;
	public final int GMAX = 100;
	public final int PMAX = 2000;
	public final int IMAX = 20;
	public final int GRAPH1 = 300;
	public final int GRAPH2 = 200;
	
	public String text1 = "";
	public String text2 = "";
	public String testImage;
	
	public JLabel l0;
	public JLabel l1;
	public JLabel l2;
	public JLabel l3;
	public JLabel l4;
	public JLabel l5;
	public JLabel l6;
	public JLabel l7;
	public JLabel l8;
	
	public JLabel tl0;
	public JLabel tl1;
	public JLabel tl2;
	public JLabel tl3;
	public JLabel tl4;
	public JLabel tl5;
	public JLabel tl6;
	public JLabel tl7;
	
	
	public JButton b1;
	public JButton b2;
	public JButton b3;
	public JButton b4;
	public JButton b5;
	public JButton b6;
	public JButton b7;
	public JButton b8;
	public JButton b9;
	public JButton b10;
	public JButton b11;
	public JButton b12;
	public JButton b13;
	public JButton b14;
	public JButton b15;
	public JButton b16;
	
	public JTextArea ta1;
	public JTextArea ta2;
	public Graphics g0;
	public Graphics g1;
	public Graphics g2;
	public Graphics g3;
	public Graphics g4;
	public Graphics g5;
	public Graphics g6;
	public Graphics g7;
	public Graphics g8;
	
	public int[] pxdb;
	public int[][][] pxd;
	
	public double[][] seqX;
	public double[][] seqY;
	public int[][] seqV;
	public int[][] seqB;
	public int[] seqN;
	public double[] radius;
	public double[][] distGP;
	public String[] figure;
	public String[] kanji;
	public int vcnt = 0;
	
	public double gx[];
	public double gy[];
	
	public int[] dx;
	public int[] dy;
	public final int UPPER_LEFT=2;
	public final int LOWER_RIGHT=6;
	public final int UPPER_RIGHT=0;
	public final int LOWER_LEFT=4;

	public byte change_flag;
	public int[] stack;
	public int[] stackX;
	public int[] stackY;
	public int stkp;
	public final int STKMAX = 2000;
	


	
	public static void main(String[] args){
		new JDE1("Dilation and Erosion Test");
	}
	
	public JDE1(String title)  {
		super(title);
		setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
		
		scale =(int) Math.floor(160D/(double)(Math.max(WIDTH,HEIGHT)));
		
		width1 = WIDTH * scale;
		height1 = HEIGHT * scale;
		image0 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR); 
		image1 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR); 
		image2 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR); 
		image3 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR); 
		image4 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR); 
		image5 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR); 
		image6 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR); 
		image7 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR); 
		image8 = new BufferedImage(GRAPH1, GRAPH2, BufferedImage.TYPE_4BYTE_ABGR); 
		
		pxdb = new int[WIDTH*HEIGHT];
		pxd = new int[MEM][WIDTH][HEIGHT];
		sumX = new int[HEIGHT];
		sumY = new int[WIDTH];
		seqX = new double[GMAX][PMAX];
		seqY = new double[GMAX][PMAX];
		seqV = new int[GMAX][PMAX];
		seqB = new int[GMAX][PMAX];
		seqN = new int[GMAX];
		neck = new int[HEIGHT];
		
		figure = new String[GMAX];
		distGP = new double[GMAX][PMAX];
		gx = new double[IMAX];
		gy = new double[IMAX];
		radius = new double[IMAX];

		stX = new int[GMAX][GMAX];
		edX = new int[GMAX][GMAX];
		
		
		stY = new int[GMAX];
		edY = new int[GMAX];
		ntX = new int[GMAX];
		
		frameX = new int[GMAX];
		frameY = new int[GMAX];
		frameW = new int[GMAX];
		frameH = new int[GMAX];
		fcenterX = new int[GMAX];
		fcenterY = new int[GMAX];
		
		frameX[0] = 0;
		frameY[0] = 0;
		frameW[0] = WIDTH;
		frameH[0] = HEIGHT;
		
		stack = new int[STKMAX];
		stackX = new int[STKMAX];
		stackY = new int[STKMAX];
		
		JPanel p1 = new JPanel();
		p1.setLayout(null);
		p1.setBackground(new Color(144,238,144));
		
		
		int lx = 50;
		int ly = 40;
		int ls = 165;
		
		int tx = 65;
		int ty = 20;
		int ts = 165;
		int tw = 120;
		int th = 15;

		int bx = 1000;
		int by = 450;
		int bs = 30;
		int bw = 170;
		int bh = 25;
		int bv = 180;
		
		int tax = 50;
		int tay = 220;
		int tas = 480;
		int taw = 450;
		int tah = 400;
		
		prepareScreen(width1, height1, image0, g0);
		l0 = new JLabel(new ImageIcon(image0));
		l0.setBounds(lx, ly, width1, height1);
		p1.add(l0);
		
		prepareScreen(width1, height1, image1, g1);
		l1 = new JLabel(new ImageIcon(image1));
		l1.setBounds(lx + ls, ly, width1, height1);
		p1.add(l1);

		prepareScreen(width1, height1, image2, g2);
		l2 = new JLabel(new ImageIcon(image2));
		l2.setBounds(lx + ls * 2, ly, width1, height1);
		p1.add(l2);
		
		prepareScreen(width1, height1, image3, g3);
		l3 = new JLabel(new ImageIcon(image3));
		l3.setBounds(lx + ls * 3, ly, width1, height1);
		p1.add(l3);
		
		prepareScreen(width1, height1, image4, g4);
		l4 = new JLabel(new ImageIcon(image4));
		l4.setBounds(lx + ls * 4, ly, width1, height1);
		p1.add(l4);
		
		prepareScreen(width1, height1, image5, g5);
		l5 = new JLabel(new ImageIcon(image5));
		l5.setBounds(lx + ls * 5, ly, width1, height1);
		p1.add(l5);
		
		
		prepareScreen(width1, height1, image6, g6);
		l6 = new JLabel(new ImageIcon(image6));
		l6.setBounds(lx + ls * 6, ly, width1, height1);
		p1.add(l6);
		
		prepareScreen(width1, height1, image7, g7);
		l7 = new JLabel(new ImageIcon(image7));
		l7.setBounds(lx + ls * 7, ly, width1, height1);
		p1.add(l7);
		
		prepareScreen(GRAPH1, GRAPH2, image8, g8);
		l8 = new JLabel(new ImageIcon(image8));
		l8.setBounds(bx, tay, GRAPH1, GRAPH2);
		p1.add(l8);
		
		
		tl0 = new JLabel();
		tl0.setBounds(lx, ty, tw, th);
		tl0.setText("[元画像]");
		p1.add(tl0);
		tl1 = new JLabel();
		tl1.setBounds(tx + ts, ty, tw, th);
		tl1.setText("[２値化]");
		p1.add(tl1);
		
		tl2 = new JLabel();
		tl2.setBounds(tx + ts * 2, ty, tw, th);
		tl2.setText("[フレーム選択]");
		p1.add(tl2);
		
		tl3 = new JLabel();
		tl3.setBounds(tx + ts * 3, ty, tw, th);
		tl3.setText("[膨張・収縮]");
		p1.add(tl3);
		
		tl4 = new JLabel();
		tl4.setBounds(tx + ts * 4, ty, tw, th);
		tl4.setText("[輪郭化]");
		p1.add(tl4);
		
		tl5 = new JLabel();
		tl5.setBounds(tx + ts * 5, ty, tw, th);
		tl5.setText("[細線化]");
		p1.add(tl5);
		
		
		tl6 = new JLabel();
		tl6.setBounds(tx + ts * 6, ty, tw, th);
		tl6.setText("[細線化認識]");
		p1.add(tl6);
		
		tl7 = new JLabel();
		tl7.setBounds(tx + ts * 7, ty, tw, th);
		tl7.setText("[認識結果]");
		p1.add(tl7);
		
		
		b1 = new JButton("① 画像を開く");
		b1.setHorizontalAlignment(JButton.LEFT);

		b1.setBounds(bx, by, bw, bh);
		p1.add(b1);
		b1.addActionListener(this);
		
		b2 = new JButton("② ラベリング");
		b2.setHorizontalAlignment(JButton.LEFT);
		b2.setBounds(bx, by + bs, bw, bh);
		p1.add(b2);
		b2.addActionListener(this);
		

		b3 = new JButton("③ フレームの選択");
		b3.setHorizontalAlignment(JButton.LEFT);
		b3.setBounds(bx, by + bs * 2, bw, bh);
		p1.add(b3);
		b3.addActionListener(this);
		
		b4 = new JButton("④ 横２つ割");
		b4.setHorizontalAlignment(JButton.LEFT);
		b4.setBounds(bx, by + bs * 3, bw, bh);
		p1.add(b4);
		b4.addActionListener(this);
		
		
		b5 = new JButton("⑤ 縦２つ割");
		b5.setHorizontalAlignment(JButton.LEFT);
		b5.setBounds(bx, by + bs * 4, bw, bh);
		p1.add(b5);
		b5.addActionListener(this);
		
		b6 = new JButton("⑥ 縦２つ自動割");
		b6.setHorizontalAlignment(JButton.LEFT);
		b6.setBounds(bx, by + bs * 5, bw, bh);
		p1.add(b6);
		b6.addActionListener(this);
		
		b7 = new JButton("⑦ 横３つ割");
		b7.setHorizontalAlignment(JButton.LEFT);
		b7.setBounds(bx, by + bs * 6, bw, bh);
		p1.add(b7);
		b7.addActionListener(this);
		
		b8 = new JButton("⑧  縦３つ割");
		b8.setHorizontalAlignment(JButton.LEFT);
		b8.setBounds(bx, by + bs * 7, bw, bh);
		p1.add(b8);
		b8.addActionListener(this);
		
		b9 = new JButton("⑨  斜め３つ割");
		b9.setHorizontalAlignment(JButton.LEFT);
		b9.setBounds(bx + bv, by, bw, bh);
		p1.add(b9);
		b9.addActionListener(this);
		
		b10 = new JButton("⑩ ４つ割");
		b10.setHorizontalAlignment(JButton.LEFT);

		b10.setBounds(bx + bv, by + bs, bw, bh);
		p1.add(b10);
		b10.addActionListener(this);
		
		b11 = new JButton("⑪ ５つ割");
		b11.setHorizontalAlignment(JButton.LEFT);
		b11.setBounds(bx + bv, by + bs * 2, bw, bh);
		p1.add(b11);
		b11.addActionListener(this);
		

		b12 = new JButton("⑫ ８つ割");
		b12.setHorizontalAlignment(JButton.LEFT);
		b12.setBounds(bx + bv, by + bs * 3, bw, bh);
		p1.add(b12);
		b12.addActionListener(this);
		
		b13 = new JButton("⑬");
		b13.setHorizontalAlignment(JButton.LEFT);
		b13.setBounds(bx + bv, by + bs * 4, bw, bh);
		p1.add(b13);
		b13.addActionListener(this);
		
		
		b14 = new JButton("⑭ 輪郭認識（整形）");
		b14.setHorizontalAlignment(JButton.LEFT);
		b14.setBounds(bx + bv, by + bs * 5, bw, bh);
		p1.add(b14);
		b14.addActionListener(this);
		
		b15 = new JButton("⑮ 輪郭認識（直接）");
		b15.setHorizontalAlignment(JButton.LEFT);
		b15.setBounds(bx + bv, by + bs * 6, bw, bh);
		p1.add(b15);
		b15.addActionListener(this);
		
		b16 = new JButton("⑯ 細線認識");
		b16.setHorizontalAlignment(JButton.LEFT);
		b16.setBounds(bx + bv, by + bs * 7, bw, bh);
		p1.add(b16);
		b16.addActionListener(this);
		
		ta1 = new JTextArea("");
		JScrollPane sc1 = new JScrollPane();
		sc1.setViewportView(ta1);
		sc1.setBounds(tax, tay, taw, tah);
		p1.add(sc1);
		
		ta2 = new JTextArea("");
		JScrollPane sc2 = new JScrollPane();
		sc2.setViewportView(ta2);
		sc2.setBounds(tax + tas, tay, taw, tah);
		p1.add(sc2);
		
		getContentPane().add(p1, BorderLayout.CENTER);

		addWindowListener(new WindowClosing() );
	    setVisible(true);
	    setExtendedState(JFrame.MAXIMIZED_BOTH);
	}
	
	
	public void actionPerformed(ActionEvent e) {
		if(e.getSource() == b1){
			//画像を開く→２値化		
			String testImage = "";
			
			JFileChooser fc = new JFileChooser( "." );
			int result = fc.showOpenDialog( null );
			if(result==JFileChooser.APPROVE_OPTION) {
				testImage = fc.getSelectedFile().getPath();

			}
			if(result==JFileChooser.CANCEL_OPTION) {
				//ta1.setText("画像の読み込みを取り消しました");
				return;
			}
			if(result==JFileChooser.ERROR_OPTION) {
				//ta1.setText( "画像が開けません" );
				return;
			}
			
			
			BufferedImage image0 = null;
			//testImage = "saPai/a9.bmp";
			text1 = "画像ファイル="+testImage;
			ta1.setText(text1);			
			
			try {image0 = ImageIO.read(new File(testImage));}
			catch (Exception e1) { e1.printStackTrace(); image0 = null;}
			
			for (int mem = 1 ; mem < MEM; mem++){
				for (int i = 0; i < WIDTH; i++){
					for (int j = 0; j < HEIGHT; j++){
						pxd[mem][i][j] = 0;
					}
				}
			}
			PixelGrabber pg = new PixelGrabber(image0 ,0 ,0 , WIDTH-2, HEIGHT-2, pxdb, WIDTH + 1, WIDTH);
			try { pg.grabPixels(); }
			catch (InterruptedException e2) { }
			
			image0 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR);
			imageDisplay(0, image0, g0, 1);
			l0.setIcon(new ImageIcon(image0));
			
			colorReduction();
			
			image1 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR);
			imageDisplay(0, image1, g1, 0);
			
			l1.setIcon(new ImageIcon(image1));
			image2 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR);
			image3 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR);
			image4 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR);
			image5 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR);
			image6 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR);
			image7 = new BufferedImage(width1, height1, BufferedImage.TYPE_4BYTE_ABGR);
			image8 = new BufferedImage(GRAPH1, GRAPH2, BufferedImage.TYPE_4BYTE_ABGR);
			
			prepareScreen(width1, height1, image2, g2);
			prepareScreen(width1, height1, image3, g3);
			prepareScreen(width1, height1, image4, g4);
			prepareScreen(width1, height1, image5, g5);
			prepareScreen(width1, height1, image6, g6);
			prepareScreen(width1, height1, image7, g7);
			prepareScreen(GRAPH1, GRAPH2, image8, g8);
			
			l2.setIcon(new ImageIcon(image2));
			l3.setIcon(new ImageIcon(image3));
			l4.setIcon(new ImageIcon(image4));
			l5.setIcon(new ImageIcon(image5));
			l6.setIcon(new ImageIcon(image6));
			l8.setIcon(new ImageIcon(image8));
			fcnt = 0;
			
		
		} else if (e.getSource() == b2){
			//ラベリング
			text1 += "切り出し"+"\n";

			copyPxd(0,0,1);
			frameN = 0;
			labelingGroup(1, 0,0,WIDTH, HEIGHT);
			imageDisplay(1,image2,g2,0);
			l2.setIcon(new ImageIcon(image2));
			framingImage(1,WIDTH, HEIGHT);
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1, Color.red, image2, g2);
			}
			l2.setIcon(new ImageIcon(image2));
			
			ta1.setText(text1);	
			
			fcnt = 0;
			
		} else if(e.getSource() == b3){
			//フレームの選択
			++fcnt;
			if (fcnt > frameN) fcnt = 1;
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1,Color.red, image2, g2);
			}		
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			text1 += "ID = "+fcnt+"\n";
			int num = seqN[fcnt];
			int area = frameW[fcnt]*frameH[fcnt];
			text1 +="num="+ num+"area="+area;
			int blank = area - num;
			text1 += "x="+frameX[fcnt] + ", y="+frameY[fcnt]+
				", w="+frameW[fcnt]+", h="+frameH[fcnt]+", blank="+blank+", cx="+fcenterX[fcnt]+
				", cy="+fcenterY[fcnt]+"\n";
			
			
			ta1.setText(text1);	
			ta2.setText(text2);
		
		} else if(e.getSource() == b4){
			//横２つ割
			
			
			int sx = frameX[fcnt];
			int sy = frameY[fcnt];
			int w = frameW[fcnt];
			int h = frameH[fcnt];
			int w1 = w / 2;
			int w2 = w - w1;
			copyPxd(fcnt, 0,2);
			copyPxd(1,2,sx, sy, w1, h);
			labelingGroup(2, sx + w1, sy, w2, h);
			copyPxd(fcnt, 2,1);
			framingImage(1,WIDTH, HEIGHT);
		    imageDisplay(1,image2,g2,0);
		    
			
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1, Color.red, image2, g2);
			}
			
			
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			
			ta1.setText(text1);	
			ta2.setText(text2);
		} else if(e.getSource() == b5){
			//縦２つ割
			
			
			int sx = frameX[fcnt];
			int sy = frameY[fcnt];
			int w = frameW[fcnt];
			int h = frameH[fcnt];
			int h1 = h / 2;
			int h2 = h - h1;
			copyPxd(fcnt, 0, 2);
			copyPxd(1,2,sx, sy, w, h1);
			
			labelingGroup(2, sx, sy + h1, w, h2);
			copyPxd(fcnt, 2, 1);
			framingImage(1,WIDTH, HEIGHT);
		    imageDisplay(1,image2,g2,0);
		    
			
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1, Color.red, image2, g2);
			}
			
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			
			ta1.setText(text1);	
			ta2.setText(text2);
		} else if(e.getSource() == b6){
			//縦２つ自動割			
			
			int sx = frameX[fcnt];
			int sy = frameY[fcnt];
			int w = frameW[fcnt];
			int h = frameH[fcnt];
			
			copyPxd(fcnt, 0, 2);
			findNeck(fcnt,2);
			if (nMin < 3){
				int yNeck = 0;
				for (int i = sy; i < sy + h; i++){
					if (nMin == neck[i]) {
						yNeck = i;
						break;
					}
				}
				int h1 = yNeck - sy + 1;
				int h2 = h - h1;
				copyPxd(1,2,sx, sy, w, h1);
				
				labelingGroup(2, sx, sy + h1, w, h2);
				copyPxd(fcnt, 2, 1);
				framingImage(1,WIDTH, HEIGHT);
			    imageDisplay(1,image2,g2,0);
			    
				
				for (int i = 1; i <= frameN; i++) {
					frameDisplay(i, 1, Color.red, image2, g2);
				}
			} else {
				text2 += "くびれは見つかりません\n";
			}
			
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			ta1.setText(text1);	
			ta2.setText(text2);
			
		} else if(e.getSource() == b7){
			//横３つ割
			
			
			int sx = frameX[fcnt];
			int sy = frameY[fcnt];
			int w = frameW[fcnt];
			int h = frameH[fcnt];
			int w1 = w / 3;
			int w3 = w / 3;
			int w2 = w - w1 - w3;
			copyPxd(fcnt, 0,2);
			copyPxd(1,2,sx, sy, w1, h);
			
			labelingGroup(2, sx + w1, sy, w2, h);
			labelingGroup(2, sx + w1 + w2, sy, w3, h);
						
			copyPxd(fcnt, 2,1);
			
			
			framingImage(1,WIDTH, HEIGHT);
		    imageDisplay(1,image2,g2,0);
		    
			
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1, Color.red, image2, g2);
			}
			
			
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			
			ta1.setText(text1);	
			ta2.setText(text2);
			
		} else if(e.getSource() == b8){
			//縦３つ割			
			
			int sx = frameX[fcnt];
			int sy = frameY[fcnt];
			int w = frameW[fcnt];
			int h = frameH[fcnt];
			int h1 = h / 3;
			int h3 = h / 3;
			int h2 = h - h1 - h3;
			copyPxd(fcnt, 0, 2);
			copyPxd(1,2,sx, sy, w, h1);
			
			labelingGroup(2, sx, sy + h1, w, h2);
			labelingGroup(2, sx, sy + h1 + h2, w, h3);
			copyPxd(fcnt, 2, 1);
			framingImage(1,WIDTH, HEIGHT);
		    imageDisplay(1,image2,g2,0);
		    
			
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1, Color.red, image2, g2);
			}
			
			
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			
			ta1.setText(text1);	
			ta2.setText(text2);
				
		} else if(e.getSource() == b9){
			//斜め３つ割（５つ割と同じ）
			int sx = frameX[fcnt];
			int sy = frameY[fcnt];
			int w = frameW[fcnt];
			int h = frameH[fcnt];
			copyPxd(fcnt, 0, 2);
			copyPxd(fcnt, 0, 3);
			
			cutDiamond(fcnt, 2, 3, image1, g1);
			l1.setIcon(new ImageIcon(image1));
			int w1 = w / 2;
			int w2 = w - w1;
			labelingGroup(3, sx, sy, w1, h);
			labelingGroup(3, sx+ w1, sy, w2, h);
			copyPxd(0,3,1);
		    imageDisplay(1,image2,g2,0);
			
			framingImage(1,WIDTH, HEIGHT);
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1, Color.red, image2, g2);
			}
			
			
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			ta1.setText(text1);	
			ta2.setText(text2);	
		} else if(e.getSource() == b10){
			//４つ割
			
			int sx = frameX[fcnt];
			int sy = frameY[fcnt];
			int w = frameW[fcnt];
			int h = frameH[fcnt];
			copyPxd(fcnt, 0, 2);
			int w1 = w / 2;
			int w2 = w - w1;
			int h1 = h / 2;
			int h2 = h - h1;
			
			copyPxd(1, 2, sx, sy, w1, h1);

			labelingGroup(2, sx + w1, sy, w2, h1);
			labelingGroup(2, sx, sy + h1, w1, h2);
			labelingGroup(2, sx + w1, sy + h1, w2, h2);

			copyPxd(fcnt, 2, 1);
			framingImage(1,WIDTH, HEIGHT);
		    imageDisplay(1,image2,g2,0);
			
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1, Color.red, image2, g2);
	
			}
			
			
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			
			ta1.setText(text1);	
			ta2.setText(text2);
		} else if(e.getSource() == b11){
			//５つ割
			int sx = frameX[fcnt];
			int sy = frameY[fcnt];
			int w = frameW[fcnt];
			int h = frameH[fcnt];
			copyPxd(fcnt, 0, 2);
			copyPxd(fcnt, 0, 3);
			
			cutDiamond(fcnt, 2, 3, image1, g1);
			l1.setIcon(new ImageIcon(image1));
			int w1 = w / 2;
			int w2 = w - w1;
			labelingGroup(3, sx, sy, w1, h);
			labelingGroup(3, sx+ w1, sy, w2, h);
			copyPxd(0, 3, 1);
		    imageDisplay(1,image2,g2,0);
			
			framingImage(1,WIDTH, HEIGHT);
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1, Color.red, image2, g2);
			}
			
			
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			ta1.setText(text1);	
			ta2.setText(text2);
		} else if(e.getSource() == b12){
			//８つ割
			
			int sx = frameX[fcnt];
			int sy = frameY[fcnt];
			int w = frameW[fcnt];
			int h = frameH[fcnt];
			copyPxd(fcnt, 0, 2);
			int w1 = w / 2;
			int w2 = w - w1;
			
			int h1 = h / 4;
			int h4 = h / 4;
			int h2 = h / 2 - h1;
			int h3 = h - h1 - h2 - h4;
			
			copyPxd(1, 2, sx, sy, w1, h1);

			labelingGroup(2, sx + w1, sy, w2, h1);
			
			labelingGroup(2, sx, sy + h1, w1, h2);
			labelingGroup(2, sx + w1, sy + h1, w2, h2);

			labelingGroup(2, sx, sy + h1 + h2, w1, h3);
			labelingGroup(2, sx + w1, sy + h1 + h2, w2, h3);
			
			labelingGroup(2, sx, sy + h1 + h2 + h3, w1, h4);
			labelingGroup(2, sx + w1, sy + h1 + h2 + h3, w2, h4);
			
			copyPxd(fcnt, 2 , 1);
			framingImage(1,WIDTH, HEIGHT);
		    imageDisplay(1,image2,g2,0);
			
			for (int i = 1; i <= frameN; i++) {
				frameDisplay(i, 1, Color.red, image2, g2);
	
			}
			
			frameDisplay(fcnt, 1, Color.yellow, image2, g2);
			findNeck(fcnt, 1);
			l2.setIcon(new ImageIcon(image2));
			
			ta1.setText(text1);	
			ta2.setText(text2);
		} else if(e.getSource() == b14){
			//膨張・収縮・輪郭化
			text2 += "輪郭化認識(整形）\n";
			for (int i = 1; i <= frameN; i++){
				pixelDilation(i, 1, 3);
				pixelErosion(i, 3, 4);
				clearPxd(i,5);
				getOutline(i,4,5);
			}
			imageDisplay(4,image3,g3,0);
			imageDisplay(5,image4,g4,0);
			l3.setIcon(new ImageIcon(image3));
			l4.setIcon(new ImageIcon(image4));
			resultImage(image7, g7);
			l7.setIcon(new ImageIcon(image7));
			ta1.setText(text1);	
			ta2.setText(text2);
		} else if(e.getSource() == b15){
			//直接輪郭化
			text2 += "輪郭化認識(直接）\n";
			for (int i = 1; i <= frameN; i++) {
				clearPxd(i,5);
				getOutline(i,1, 5);
			}
			imageDisplay(5,image4,g4,0);
			l4.setIcon(new ImageIcon(image4));
			resultImage(image7, g7);
			l7.setIcon(new ImageIcon(image7));
			ta1.setText(text1);	
			ta2.setText(text2);
		} else if(e.getSource() == b16){
			//細線化認識
			text2 += "細線化認識"+"\n";
			frameN = 0;
			copyPxd(0,0,6);
			thinImage(6,7);
			imageDisplay(7, image5, g5, 0);
			l5.setIcon(new ImageIcon(image5));
			labelingGroup(7, 0, 0, WIDTH, HEIGHT);
			imageDisplay(7, image6, g6, 0);
			ta1.setText(text1);		
			l6.setIcon(new ImageIcon(image6));
			text2 += "図形は" + frameN+" 個あります"+"\n";
			/*
			for (int i = 1; i <= frameN; i++){
				statistics(i);
			}
			*/
			ta1.setText(text1);	
			ta2.setText(text2);
		}
		
	}
	
	public void cutDiamond(int fr, int mem1, int mem2, BufferedImage image, Graphics g){
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		double r = Math.sqrt(w * w + h * h)/(2 * Math.sqrt(2) + 4);
		int d = (int)(Math.sqrt(2) * r);
		int x1 = sx + w / 2;
		int y1 = sy + h / 2 - d;
		int x2 = sx + w / 2 - d;
		int y2 = sy + h / 2;
		int x3 = sx + w / 2;
		int y3 = sy + h / 2 + d;
		int x4 = sx + w / 2 + d;
		int y4 = sy + h / 2;
		int wx[] = {x1*scale, x2*scale, x3*scale, x4*scale, x1*scale};
		int wy[] = {y1*scale, y2*scale, y3*scale, y4*scale, y1*scale};
	    g = image.createGraphics();
		g.setColor(Color.yellow);
	    g.drawPolyline(wx, wy, 5);
	    int i = 0;
		for (int y = y1; y < y3; y++){
			for(int x = x1 -i; x < x1 + i; x++){
				if (pxd[mem1][x][y] == -1) pxd[mem2][x][y]= fr;
			}
			if (y < y2)	++i; else --i;
		}
		
	}
	
	public void findNeck(int fr, int mem){
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		for (int y = sy; y < sy + h-1; y++){
			int c = 0;
			
			for (int x = sx; x < sx + w; x++){
				int d1 = pxd[mem][x][y];
				int d2 = pxd[mem][x][y+1];
				if (d1 != 0 && d2 != 0) ++c;

			}
			neck[y] = c;
		}
		nMin = neck[sy];
		for (int y = sy+1; y < sy + h -1; y++){
			if (nMin > neck[y]) nMin = neck[y];
		}
		
		
		drawGraph(fr,"y座標","y方向連結数", neck, sy, sy+h-2, image8, g8);
		l8.setIcon(new ImageIcon(image8));
		return;
	}
	
	public void drawGraph(int fr, String title1, String title2, int[] data, 
		int st, int ed, BufferedImage image, Graphics g){
		if (st < ed){
			g = image.createGraphics();
			g.setColor(Color.BLACK);
			g.fillRect(0,0,GRAPH1, GRAPH2);	
			int pt = 12;
			int x0 = 40;
			int y0 = GRAPH2 - 20;
			int x1 = GRAPH1 - 10;
			int y1 = 30;
			int max = data[st];
			int min = data[st];
			for (int i = st; i <= ed; i++){
	
				if (max < data[i]) max = data[i];
				if (min > data[i]) min = data[i];
			}
			String sMax = String.valueOf(max);
			String sMin = String.valueOf(min);
			String sSt = String.valueOf(st);
			String sEd = String.valueOf(ed);
			String sTitle2 = "FRAME="+String.valueOf(fr)+":"+title2;
			
			Font f = new Font("Monospaced", Font.BOLD, pt);
			
			g.setColor(Color.YELLOW);
			g.setFont(f);
			g.drawString(title1, GRAPH1/2 + x0 / 2 - (title1.length()) * pt/2, y0 + pt);
			g.drawString(sTitle2, GRAPH1/2 + x0 / 2 - (sTitle2.length()) * pt/2, y1 - pt);
			g.drawString(sMax, x0 - (sMax.length()) * pt/2-5, y1);
			g.drawString(sMin, x0 - (sMin.length()) * pt/2-5, y0);
			g.drawString(sSt, x0 , y0 + pt);
			g.drawString(sEd, x1 - (sEd.length())*pt/2, y0 + pt);
		
			
			g.setColor(Color.WHITE);
			g.drawLine(x0, y0, x1, y0); 
			g.drawLine(x0, y0, x0, y1-20);
			g.drawLine(x0, y1, x1, y1); 
			g.drawLine(x0, y0 - (y0-y1)/2, x1, y0 - (y0-y1)/2); 
			int num = ed - st;
			if (max > min){
				for (int i = 0; i < num; i++){
					int d1 = data[st + i];
					int d2 = data[st + i + 1];
					int xd1 = x0 + i * (x1 - x0) / num;
					int xd2 = x0 + (i + 1) * (x1 - x0) / num;
					int yd1 = (y0 * (max - d1) + y1 * (d1 - min))/(max - min);
					int yd2 = (y0 * (max - d2) + y1 * (d2 - min))/(max - min);
					g.drawLine(xd1, yd1, xd2, yd2);
				}
			}
		}
	}
	
	public void prepareScreen(int width, int height, BufferedImage img, Graphics g){
		g = img.createGraphics();
		g.setColor(Color.GREEN);
		g.fillRect(0,0,width, height);		
	}

	public void setPixel(int x, int y, int[] pxd, int width, Graphics g){
		try {
			int pixel = pxd[x + y * width];
			if (pixel == 1) {
				g.setColor(Color.WHITE);
			} else {
				g.setColor(Color.BLACK);
			}
			g.fillRect(x*scale, y*scale, scale-1, scale-1);
		} catch (Exception e){
		}
	}
	
	public class WindowClosing extends WindowAdapter{
		public void windowClosing(WindowEvent e){
			int ans = JOptionPane.showConfirmDialog(JDE1.this, "終了しますか？");
			if (ans == JOptionPane.YES_OPTION){
				System.exit(0);  
			}
		}
	}
	public void imageDisplay(int mem, BufferedImage image, Graphics g, int sw){
		int[] color16 = {0,0x9acd32,0xb0e0e6,0xdc143c,0xff8c00,0xffff00,0x00bfff,
				0xee82ee,0xd3d3d3,0x8fbc8b,0x48d1cc,0xcfa072,0xffdead,0x9932cc,
				0xffb6c1,0xffffff,};
		
		g = image.createGraphics();
		g.setColor(Color.GREEN);
		g.fillRect(0,0,width1, height1);
		for (int y = 0; y < HEIGHT; y++){
			for (int x = 0; x < WIDTH; x++){
				if (sw == 1){
					int pixel = pxdb[x + y * WIDTH];
					int red   = (pixel >> 16) & 0xff;
					int green = (pixel >>  8) & 0xff;
					int blue  = (pixel      ) & 0xff;
				    g.setColor(new Color(red,green,blue));
				} else {
					int cnum = pxd[mem][x][y];
					if(cnum == -1) cnum = 15;
					cnum %= 16;
					int pixel = color16[cnum];
			        int red   = (pixel >> 16) & 0xff;
				    int green = (pixel >>  8) & 0xff;
				    int blue  = (pixel      ) & 0xff;
				    g.setColor(new Color(red,green,blue));
				}
				g.fillRect(x * scale, y * scale, scale-1, scale-1);
			}
		}
		
		

	}
	public void frameDisplay(int fr, int mem, Color color,BufferedImage image, Graphics g){
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		g = image.createGraphics();
		g.setColor(color);
		g.drawRect(sx * scale, sy * scale, w * scale, h * scale);
		
	}
	
	public void labelingGroup(int mem, int sx, int sy, int w, int h){
		stkp = 0;
		for (int y = sy; y < sy + h - 1; y++) {
			for (int x = sx; x < sx + w - 1; x++) {
				if (pxd[mem][x][y] == -1) {
					xs = x;
					ys = y;
					++frameN;
					int ns = 1;
					int sp = 7;
					recordPoint(frameN,ns,xs,ys,mem,0);
					
					while (sp > 0){
						searchPoint(frameN, ns, xs, ys, mem, sx, sy, w, h);
						sp = pop();
						if (sp > 0){
							movePoint(sp);
							++ns;
							recordPoint(frameN,ns,xs,ys,mem, sp);
						}
					}
					
				}
				
			}
		}
	}
	public void clearLabeling(int fr, int mem){
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		for (int y = sy; y < sy + h; y++){
			for (int x = sx; x < sx + w; x++){
				int px = pxd[mem][x][y];
				if(px == fr) pxd[mem][x][y] = -1; 
			}
		}
	}
	public void reLabeling(int fr, int mem) {
		stkp = 0;
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		for (int y = sy; y < sy + h - 1; y++) {
			for (int x = sx; x < sx + w - 1; x++) {
				if (pxd[mem][x][y] == -1) {
					xs = x;
					ys = y;
					int ns = 1;
					int sp = 7;
					recordPoint(fr, ns, xs, ys, mem, 0);
					
					while (sp > 0){
						searchPoint(fr, ns, xs, ys, mem, sx, sy, w, h);
						sp = pop();
						if (sp > 0){
							movePoint(sp);
							++ns;
							recordPoint(fr, ns, xs, ys, mem, sp);
						}
					}
					
				}
				
			}
		}
	}
	
	
	public void getOutline(int fr, int mem1, int mem2){
		text1 += "FRAME="+fr+"\n";
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		int flag = 0;
		int x0 = sx;
		int y0 = sy;

		for (int y = sy; y < sy + h ; y++){
			for (int x = sx; x < sx + w; x++){
				int px = pxd[mem1][x][y];
				   if (flag == 0 && px == fr){
					flag = 1;
					x0 = x;
					y0 = y;
					break;
				}
			}
		}
		if (flag == 1){
			int ns = 1;
			int[] dx = {-1, -1, 0, 1, 1, 1, 0, -1};
			int[] dy = {0, 1, 1, 1, 0, -1, -1, -1};
			int[] pv = {7, 7, 1, 1, 3, 3, 5, 5};
			int x = x0;
			int y = y0;
			pxd[mem2][x][y] = fr;
			int vec = 1;
			recordPoint(fr,ns,x,y,mem2,vec);
			int sw = 0;
			int c = 0;
			boolean isEnd = false;
			while(!isEnd){
				++c;
				sw = 0;
				for (int i = vec; i < vec + 8; i++){
					
					int j = i % 8;
					int x1 = x + dx[j];
					int y1 = y + dy[j];
					int px = pxd[mem1][x1][y1];
					if (sw == 0 && px == fr){
						x = x1;
						y = y1;
						if (x == x0 && y == y0){
							isEnd = true;
							break;
						} else{
							++ns;
							vec = pv[j];
							recordPoint(fr,ns,x,y,mem2,vec);
							sw = 1;
						}

					}
				}
				if(sw == 0) isEnd = true;
			}

		}
	}
	public void getOutline2(int fr, int mem1, int mem2){
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		for (int y = sy; y < sy + h ; y++){
			for (int x = sx; x < sx + w; x++){
				int px = pxd[mem1][x][y];
				if (px == fr){
					int px1 = pxd[mem1][x - 1][y];
					int px2 = pxd[mem1][x + 1][y];
					int px3 = pxd[mem1][x][y + 1];
					int px4 = pxd[mem1][x][y - 1];
					if (px1 == fr && px2 == fr && px3 == fr && px4 == fr){
						pxd[mem2][x][y] = 0;
					} else {
						pxd[mem2][x][y] = px;
					}
					
				}
			}
		}
	}
	public void colorReduction(){
		for (int y = 0; y < HEIGHT; y++){
			for (int x = 0; x < WIDTH; x++){
				int pixel = pxdb[x + y * WIDTH];
		        int red   = (pixel >> 16) & 0xff;
			    int green = (pixel >>  8) & 0xff;
			    int blue  = (pixel      ) & 0xff;
			    double light = 
			    	(double)red * 0.299 + (double)green * 0.587 + (double)blue * 0.114;		    
			    if (light > THL || x == 0 || y == 0 || x == WIDTH-1 || y == HEIGHT -1) {
			    	pxd[0][x][y] = 0;
			    } else {
			    	pxd[0][x][y] = -1;
				}

			}	    

		}
		
	}
	public void pixelDilation(int fr, int mem1, int mem2){
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		for (int y = sy; y < sy + h ; y++){
			for (int x = sx; x < sx + w; x++){
				int px = pxd[mem1][x][y];
				if (px  == fr) {
					pxd[mem2][x][y] = fr;
				} else if (px == 0){
					int count = 0;
					for (int i = -1; i <=1; i++){
						for (int j= -1; j <=1; j++){
							int px1 = pxd[mem1][x + i][y + j];
							if (px1 == fr) ++count;
						}
					}
					if (count >= 5) {
						pxd[mem2][x][y] = fr;
					}else {
						pxd[mem2][x][y] = 0;
					}
				}
			}
		}
	}
	public void pixelErosion(int fr, int mem1, int mem2){
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		for (int y = sy; y < sy + h; y++){
			for (int x = sx; x < sx + w; x++){
				int px = pxd[mem1][x][y];
				if (px == 0) {
					pxd[mem2][x][y] = 0;
				}else if (px == fr){
					int count = 0;
					for (int i = -1; i <=1; i++){
						for (int j= -1; j <=1; j++){
							int px1 = pxd[mem1][x + i][y + j];
							if (px1 == 0) ++count;
						}
					}
					if (count >= 5) {
						pxd[mem2][x][y] = 0;
					} else {
						pxd[mem2][x][y] = fr;
					}
				}
			}
		}
	}
	
	public void framingImage(int mem, int width, int height){

    	for (int i = 1; i <= frameN; i++){
    		int left = width;
    		int right = 0;
    		int top = height;
    		int bottom = 0;
    		for (int y = 0; y < height; y++){
    			for (int x = 0; x < width; x++){
    				int px = pxd[mem][x][y];
    				if (px == i && left > x) left = x;
    				if (px == i && right < x) right = x;
    				if (px == i && top > y) top = y;
    				if (px == i && bottom  < y) bottom = y;
     			}
    		}
	    	frameX[i] = left;
			frameY[i] = top;
			frameW[i] = right - left + 1;
			frameH[i] = bottom - top + 1;

			fcenterX[i] = frameX[i]+frameW[i]/2;
			fcenterY[i] = frameY[i]+frameH[i]/2;
			
    	}
 	}
    	
   
   
	public void recordPoint(int fr, int n, int x, int y, int mem, int sp) {
		seqX[fr][n] = x;
		seqY[fr][n] = y;
		seqV[fr][n] = sp;
		pxd[mem][x][y] = fr;
		seqN[fr]=n;
	}
	
	public void searchPoint(int fr, int n, int x, int y, int mem, 
			int sx, int sy, int w, int h) {
		int count = 0;
		int[] dx = {1,1,0,-1,-1,-1,0,1};
		int[] dy = {0,-1,-1,-1,0,1,1,1};
		for (int i = 0; i < 8; i++){
			int sp = i + 1;
			int x1 = x + dx[i];
			int y1 = y + dy[i];
			if (sx <=x1 && x1 < sx + w && sy <= y1 && y1 < sy + h){
				if (pxd[mem][x1][y1] == -1) {
					push(sp);
					pxd[mem][x1][y1] = 0;
					++count;
				}
			}
		}
		seqB[fr][n] = count;
		return;
	}
	
	public void movePoint(int sp) {
		if (sp > 0) {
			int[] dx = {1,1,0,-1,-1,-1,0,1};
			int[] dy = {0,-1,-1,-1,0,1,1,1};
			xs = xs + dx[sp-1];
			ys = ys + dy[sp-1];
		}
	}
	public void push(int sp){
		++stkp;
		stack[stkp] = sp;
		stackX[stkp] = xs;
		stackY[stkp] = ys;
	}
	
	public int pop(){
		int sp = -1;
		if (stkp > 0){
			sp = stack[stkp];
			xs = stackX[stkp];
			ys = stackY[stkp];
			--stkp;
		}
		return sp;
	}
	public int hexToDec(String str){
		int n=0;	
		try {
			n = Integer.parseInt(str,16);
		} catch(Exception e){
			ta1.setText(e.toString());
		}
		return n;
	}
	
	
	
	public boolean isClosed(int fr){
		boolean result = false;
		int num = seqN[fr];
		double x1 = seqX[fr][1];
		double y1 = seqY[fr][1];
		double x2 = seqX[fr][num];
		double y2 = seqY[fr][num];
		if (Math.abs(x2-x1)<=1 && Math.abs(y2-y1)<=1){
			result = true;
		}
		
		return result;
		
	}
	
	
	public void copyPxd(int mem1, int mem2, int sx, int sy, int width, int height){
		
		for (int x = sx; x < sx + width; x++){
			for (int y = sy; y < sy + height; y++){
				pxd[mem2][x][y] = pxd[mem1][x][y];
			}
		}
	}
	
	public void copyPxd(int fr, int mem1, int mem2){
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		copyPxd(mem1, mem2, sx, sy, w, h);
	}
	
	public void clearPxd(int fr, int mem){
		int sx = frameX[fr];
		int sy = frameY[fr];
		int w = frameW[fr];
		int h = frameH[fr];
		for (int x = sx; x < sx + w; x++){
			for (int y = sy; y < sy + h; y++){
				if (pxd[mem][x][y] == fr) pxd[mem][x][y] = 0;
			}
		}
	}
	
	public void thinImage(int mem1, int mem2){
		int count = 0;
		do{
			++count;
	        change_flag=0;
	        copyPxd(mem1,mem2,0,0,WIDTH, HEIGHT); //描画とコピー
	        for(int j=1;j<HEIGHT-1;j++)  //左上から細線化
	           for(int i=1;i<WIDTH-1;i++)
	              if(pxd[mem1][i][j] == -1) thinImage1(mem1,mem2,i,j,UPPER_LEFT);
	
	        copyPxd(mem2,mem1,0,0,WIDTH, HEIGHT);    //描画とコピー
	        for(int j=HEIGHT-2;j>=1;j--)    //右下から細線化
	           for(int i=WIDTH-2;i>=1;i--)
	              if(pxd[mem1][i][j] == -1) thinImage1(mem1,mem2,i,j,LOWER_RIGHT);
	
	        copyPxd(mem2,mem1,0,0,WIDTH, HEIGHT);    //描画とコピー
	        for(int j=1;j<HEIGHT-1;j++) //右上から細線化
	           for(int i=WIDTH-2;i>=1;i--)
	              if(pxd[mem1][i][j] == -1) thinImage1(mem1,mem2,i,j,UPPER_RIGHT);
	
	        copyPxd(mem2,mem1,0,0,WIDTH, HEIGHT); //描画とコピー
	        for(int j=HEIGHT-2;j>=1;j--) //左下から細線化
	           for(int i=1;i<WIDTH-1;i++)
	              if(pxd[mem1][i][j] == -1) thinImage1(mem1,mem2,i,j,LOWER_LEFT);
	        copyPxd(mem2,mem1,0,0,WIDTH, HEIGHT);
	        
		}while(change_flag==1);
  }

  //細線化のメソッド
  public void thinImage1(int mem1, int mem2, int i,int j,int start){

     byte[] p=new byte[8];
     int product,sum;

     p[0]=(byte)(-pxd[mem1][i-1][j-1]);
     p[1]=(byte)(-pxd[mem1][i-1][j]);
     p[2]=(byte)(-pxd[mem1][i-1][j+1]);
     p[3]=(byte)(-pxd[mem1][i][j+1]);
     p[4]=(byte)(-pxd[mem1][i+1][j+1]);
     p[5]=(byte)(-pxd[mem1][i+1][j]);
     p[6]=(byte)(-pxd[mem1][i+1][j-1]);
     p[7]=(byte)(-pxd[mem1][i][j-1]);

     for(int k=start;k<start+3;k++){
        product=p[k % 8]*p[(k+1) % 8]*p[(k+2) % 8];
        sum=p[(k+4) % 8]+p[(k+5) % 8]+p[(k+6) % 8];
        if(product==1 && sum==0){
           pxd[mem2][i][j] = 0;   //消去する
           change_flag=1;
           return;
        }
     }

  }
  public void diagonalDistance(int fr){
	  	text2 += "["+fr+"]番目のフレーム　対角線との距離\n";
		
		int num = seqN[fr];
		int[] data = new int[PMAX];
		for (int i = 1 ; i <= num; i++){
			int x1 = frameX[fr];
			int y1 = frameY[fr];
			int x2 = x1 + frameW[fr]-1;
			int y2 = y1 + frameH[fr]-1;
			
			double x3 = seqX[fr][i];
			double y3 = seqY[fr][i];
			data[i] = (int)(Math.abs(x3*(y2-y1)-y3*(x2-x1)+x2*y1-x1*y2)/Math.sqrt((x2-x1)*(x2-x1)+(y2-y1)*(y2-y1)));
			text2 += "data[" + i + "]="+ data[i]+"\n"; 
		}
		drawGraph(fr,"y座標", "対角線との距離", data, 1, num, image8, g8);
		
		
		l8.setIcon(new ImageIcon(image8));
  }
					
  public void recognizeImage(int fr){
		text2 += fr+"番目の図形\n";
		int num = seqN[fr];
		if (num <= 3){
			figure[fr]="点またはノイズ";
			text2 += figure[fr]+"\n";
		} else {
			gx[fr] = aveData(seqX[fr], num);
			gy[fr] = aveData(seqY[fr], num);
			text2 += "重心("+gx[fr]+", "+gy[fr]+")\n";
			 
			double sum2 = 0;
			for (int i = 1 ; i <= num; i++){
				double x1 = seqX[fr][i];
				double y1 = seqY[fr][i];
				double d =Math.sqrt((x1 - gx[fr]) * (x1 - gx[fr]) + (y1 - gy[fr]) *  (y1 - gy[fr]));
				sum2 += d * d;
				distGP[fr][i] = Math.round(d*10)/10D;
				
			}
			double dAve =aveData(distGP[fr],num);
			
			
			radius[fr] = dAve;
			double ave2 = sum2 / num;
			
			double std = Math.sqrt(ave2 - dAve * dAve);
			
			std = Math.round(std*10)/10D;
			double per= std*100/dAve;
			per = Math.round(per*10)/10D;
			
			double per2 = Math.round(dAve*2000/(double)(WIDTH)/10D);
			
			text2 += "半径="+dAve+"\n標準偏差="+ std+"偏差率" + per+"%\n";
			text2 += "大きさ"+ per2+"%\n";
			String str = "";
			if (per < 50) {
				
				if (per2 > 50) {
					str = "大きい";
				}else if(per2>30){
					str = "中くらいの";
				} else{
					str = "小さい";
				}
				figure[fr] = str + "円";
				text2 += figure[fr] + "\n";
				
			}
			
		}
	}
  public void resultImage(BufferedImage image, Graphics g){
	  int[] color16 = {0,0x9acd32,0xb0e0e6,0xdc143c,0xff8c00,0xffff00,0x00bfff,
				0xee82ee,0xd3d3d3,0x8fbc8b,0x48d1cc,0xcfa072,0xffdead,0x9932cc,
				0xffb6c1,0xffffff,};
		
		g = image.createGraphics();
		g.setColor(Color.WHITE);
		g.fillRect(0,0,width1, height1);
		for (int i = 1; i <= frameN; i++){
			i %= 16;
			int pixel = color16[i];
	        int red   = (pixel >> 16) & 0xff;
		    int green = (pixel >>  8) & 0xff;
		    int blue  = (pixel      ) & 0xff;
		    g.setColor(new Color(red,green,blue));
		    int x1 = frameX[i];
		    int y1 = frameY[i];
		    int w = frameW[i];
		    int h = frameH[i];
		    
			g.fillOval(x1 * scale, y1 * scale, w * scale, h * scale);
			
		}
  }
  public double aveData(double[] data, int num){
	  double ave = 0;
	  double sum = 0;
	  if (num > 0){
		  for (int i = 0; i < num; i++){
			  sum += data[i];
		  }
		  ave = sum / (double)num;
		  ave = Math.round(ave*10D)/10D;
	  }
	  return ave;
  }
  public double aveData2(int[] data, int num){
	  double ave = 0;
	  double sum = 0;
	  if (num > 0){
		  for (int i = 0; i < num; i++){
			  sum += data[i]*data[i];
		  }
		  ave = sum / (double)num;
		  ave = Math.round(ave*10D)/10D;
	  }
	  return ave;
  }
}



